#!/bin/bash

###################### MERGE SOURCE TREE  ##########################

if [ $# -lt 1 ]; then
	echo "请输入源分支"
	exit
fi

git reset --hard
THIS_BRANCH=`git branch | grep "*"  | awk -F' ' '{print $2}'`

git checkout -b my_test --force

LAST_VERSION=`git log  -n 1  --pretty="%H" Makefile`
SRC_BRANCH=$1

# 展开合并
git merge $SRC_BRANCH

# 提交合并
COMMIT_MSG=`git shortlog HEAD...${LAST_VERSION}`

git checkout $THIS_BRANCH --force

git merge --no-commit --no-ff $SRC_BRANCH
git commit -s -m "Merge branch $SRC_BRANCH into $THIS_BRANCH

$COMMIT_MSG
"
git branch -D my_test

###################### UPDATE KERNEL VERSION ##########################

# 更新 Makefile 的版本信息
V=`sed -n 's/^EXTRAVERSION = -//p' Makefile`
let NOW=$((V))+1
sed -i "/EXTRAVERSION =/d" Makefile
sed -i "/SUBLEVEL =/aEXTRAVERSION = -${NOW}" Makefile
VERSION=`sed -n 's/^VERSION = //p' Makefile`
PATCHLEVEL=`sed -n 's/^PATCHLEVEL = //p' Makefile`
SUBLEVEL=`sed -n 's/^SUBLEVEL = //p' Makefile`

# 新增 changelog 信息
TEMPFILE="/tmp/.changelog"
DATE_=`LC_ALL=en_US.UTF-8 date -d today +'%a %b %d %Y'`
echo "* $DATE_ Jackie Liu <liuyun01@kylinos.cn> - ${VERSION}.${PATCHLEVEL}.${SUBLEVEL}-${NOW}" > $TEMPFILE
git log HEAD...${LAST_VERSION} --pretty=oneline --pretty="format:- [%h] %s" | grep -v "Merge branch" >> $TEMPFILE
echo "" >> $TEMPFILE

sed -i "/%changelog/r $TEMPFILE" rpmbuild/SPECS/kernel.spec

rm -rf $TEMPFILE

git commit -s -am  "Update kernel version to ${VERSION}.${PATCHLEVEL}.${SUBLEVEL}-${NOW}

- 更新内核至 ${VERSION}.${PATCHLEVEL}.${SUBLEVEL}-${NOW}"
